// Generated by CoffeeScript 1.10.0
var _defaultCallbackFn, _isArray, _isError, _isFunction, _isNumeric, _isObject, _isString, _validating, createJoin, createMuxFn, createSeqFn, debug, exports, ficent,
  slice = [].slice,
  hasProp = {}.hasOwnProperty;

debug = require('debug')('ficent');


/*
Error 처리가 핵심이다. 
그렇다면, Error Handler를 식별해야하는데, 1. Arity로 식별. 2. 고유 Property로 식별
Arity로 체크해도 무방 할듯하다. 어차피 입력 컨텍스트가 다르면, 무소용이니까..
다만, 가변 인수인 경우. -> 가변인수인 함수를 물리는 케이스가 있을까...?
그런데 이렇게 간다면...Async와 비슷해지지 않는가?
Arity가 다르면, 아규먼트도 다를테니, 별 문제가 없겠다.

다만, Ficent로 묶었는데, Ficent의 입력으로 애초부터 Err가 포함되어 오는 경우는?
달리, Null부터 오는 경우는...?
처음 호출될떄, 첫 인수가 Error인경우와 아닌경우 Base Arity를 조정하면 될까?
첫 인수가 NULL이거나 Err일때를 Callback 상황으로 가정하면 별 문제 없을듯...
일반적인 경우 첫 인수가 NULL인경우는 거의 없다..
 */

_isNumeric = function(obj) {
  return !_isArray(obj) && (obj - parseFloat(obj) + 1) >= 0;
};

_isString = function(obj) {
  return typeof obj === 'string' || obj instanceof String;
};

_isArray = Array.isArray || function(obj) {
  return Object.prototype.toString.call(obj) === "[object Array]";
};

_isError = function(obj) {
  return obj instanceof Error;
};

_isFunction = function(obj) {
  return !!(obj && obj.constructor && obj.call && obj.apply);
};

_isObject = function(obj) {
  return !!obj && obj.constructor === Object;
};

_defaultCallbackFn = function(err) {
  if (err) {
    console.error(err);
    console.error(err.stack);
    throw err;
  }
};

_defaultCallbackFn.desc = '_defaultCallbackFn';

_validating = function(fns, prefix) {
  var i, inx, item, len, results1;
  results1 = [];
  for (inx = i = 0, len = fns.length; i < len; inx = ++i) {
    item = fns[inx];
    if (!item.desc) {
      item.desc = prefix + "." + inx;
    }
    if (_isArray(item)) {
      results1.push(_validating(item, item.desc));
    } else if (_isFunction(item)) {

    } else if (_isString(item)) {

    } else {
      throw new Error('item of ficent flow must be function or array');
    }
  }
  return results1;
};

createJoin = function(strict) {
  var _unifyErrors, callOut, errors, finished, fns, inFns, outFn, results;
  if (strict == null) {
    strict = true;
  }
  errors = [];
  results = [];
  finished = [];
  inFns = [];
  outFn = void 0;
  _unifyErrors = function(errors) {
    var error, errs;
    errs = errors.filter(function(err) {
      return err;
    });
    error = void 0;
    if (errs.length > 0) {
      error = errs[0];
      error.errors = errors;
    }
    return error;
  };
  callOut = function() {
    var allFnished, err;
    allFnished = finished.every(function(v) {
      return v;
    });
    if (allFnished && outFn) {
      err = _unifyErrors(errors);
      debug('join done');
      return outFn.apply(null, [err].concat(slice.call(results)));
    }
  };
  fns = {
    "in": function(varName) {
      var _cb_forked, inx;
      if (varName == null) {
        varName = null;
      }
      varName = varName;
      inx = errors.length;
      errors.push(void 0);
      results.push(void 0);
      finished.push(false);
      _cb_forked = function() {
        var err, values;
        err = arguments[0], values = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        if (finished[inx] && strict) {
          throw new Error('should call `callback` once');
        }
        errors[inx] = err;
        if (values.length === 1) {
          values = values[0];
        }
        results[inx] = values;
        if (varName) {
          results[varName] = values;
        }
        finished[inx] = true;
        return callOut();
      };
      inFns.push(_cb_forked);
      return _cb_forked;
    },
    out: function(fn) {
      outFn = fn;
      return callOut();
    }
  };
  return fns;
};

createMuxFn = function() {
  var fns, forkingFns, hint, k, muxArgs, newFn, v;
  muxArgs = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  hint = void 0;
  if (muxArgs.length === 1) {
    fns = muxArgs[0];
  } else {
    hint = muxArgs[0], fns = muxArgs[1];
  }
  newFn = function() {
    var _insideCb, args, i, join, outCallback;
    args = 2 <= arguments.length ? slice.call(arguments, 0, i = arguments.length - 1) : (i = 0, []), outCallback = arguments[i++];
    if (typeof outCallback !== 'function') {
      args.push(outCallback);
      outCallback = _defaultCallbackFn;
    }
    debug('mux    ', newFn.desc, '->', outCallback.desc);
    join = createJoin();
    forkingFns.forEach(function(flow, inx) {
      var _forkedEnd, cbIn;
      cbIn = join["in"]();
      _forkedEnd = function() {
        var err, values;
        err = arguments[0], values = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        debug('_forkedEnd', _forkedEnd.desc);
        return cbIn.apply(null, [err].concat(slice.call(values)));
      };
      return flow.apply(null, slice.call(args).concat([_forkedEnd]));
    });
    _insideCb = function() {
      var args, err;
      err = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      debug('mux done', err, args);
      if (err) {
        err.hint = err.hint || hint;
        err.ficentFn = err.ficentFn || newFn;
      }
      return outCallback.apply(null, [err].concat(slice.call(args)));
    };
    return join.out(_insideCb);
  };
  for (k in hint) {
    if (!hasProp.call(hint, k)) continue;
    v = hint[k];
    Object.defineProperty(newFn, k, {
      value: v,
      writable: true
    });
  }
  newFn.desc = newFn.desc || 'fork';
  _validating(fns, newFn.desc);
  forkingFns = fns.map(function(flow, inx) {
    var _fn;
    _fn = createSeqFn({
      desc: newFn.desc + ".flow-wrap." + inx
    }, flow);
    return _fn;
  });
  return newFn;
};

createSeqFn = function() {
  var _startArg, args, flowFns, hint, k, startFn, v;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  hint = void 0;
  if (args.length === 1) {
    flowFns = args[0];
  } else {
    hint = args[0], flowFns = args[1];
  }
  if (!_isArray(flowFns)) {
    flowFns = [flowFns];
  }
  _startArg = function() {
    var args, done, first, i, outCallback, startErr;
    args = 2 <= arguments.length ? slice.call(arguments, 0, i = arguments.length - 1) : (i = 0, []), done = arguments[i++];
    first = args[0];
    startErr = null;
    if (first === null || first === void 0 || _isError(first)) {
      startErr = args.shift();
    }
    outCallback = _defaultCallbackFn;
    if (done) {
      if (typeof done !== 'function') {
        args.push(done);
      } else {
        outCallback = done;
      }
    }
    return [startErr, args, outCallback];
  };
  startFn = function() {
    var _call_next_fn, _createTmpCB, _toss_context, args, outCallback, ref, startArgs, startErr;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    outCallback = null;
    ref = _startArg.apply(null, args), startErr = ref[0], args = ref[1], outCallback = ref[2];
    startArgs = args;
    _toss_context = {
      fnInx: 0,
      is_cancled: false
    };
    _createTmpCB = function(fn_desc) {
      var called, cb_callcheck;
      called = false;
      cb_callcheck = function() {
        var args, err;
        err = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        if (_toss_context.is_cancled === true) {
          return;
        }
        if (called === true) {
          err = err || new Error('toss is called twice.');
          _call_next_fn(err);
          return;
        }
        called = true;
        debug.apply(null, ['seq-done ', cb_callcheck.desc, 'with'].concat(slice.call(args)));
        return _call_next_fn.apply(null, [err].concat(slice.call(args)));
      };
      cb_callcheck.done = cb_callcheck["return"] = function() {
        var args;
        args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        _toss_context.fnInx = flowFns.length;
        return cb_callcheck.apply(null, args);
      };
      cb_callcheck.cancel = function(err) {
        if (err == null) {
          err = new Error('Canceled');
        }
        _toss_context.fnInx = flowFns.length;
        cb_callcheck(err);
        return _toss_context.is_cancled = true;
      };
      cb_callcheck.err = function(nextFn) {
        return function() {
          var args, err, errMayBe, error1;
          errMayBe = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
          if (_isError(errMayBe)) {
            return cb_callcheck.apply(null, [errMayBe].concat(slice.call(args)));
          }
          try {
            return nextFn.apply(null, [errMayBe].concat(slice.call(args)));
          } catch (error1) {
            err = error1;
            return cb_callcheck(err);
          }
        };
      };
      cb_callcheck.setVar = function() {
        var names;
        names = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        return cb_callcheck.err(function() {
          var args, err, i, inx, len, n, value;
          err = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
          for (inx = i = 0, len = args.length; i < len; inx = ++i) {
            value = args[inx];
            n = names[inx];
            if (n) {
              cb_callcheck["var"](n, value);
            }
          }
          return cb_callcheck.apply(null, [err].concat(slice.call(args)));
        });
      };
      cb_callcheck.goto = function() {
        var args, inx, label;
        label = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        if (label === 'first') {
          inx = 0;
        } else if (label === 'last') {
          inx = flowFns.length - 1;
        } else {
          inx = flowFns.indexOf(label);
          if (inx < 0) {
            throw new Error('Failed to goto ' + label);
          }
        }
        _toss_context.fnInx = inx;
        return cb_callcheck.apply(null, [null].concat(slice.call(args)));
      };
      cb_callcheck["var"] = function() {
        var args, value, var_name;
        args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        if (args.length === 2) {
          var_name = args[0], value = args[1];
          return _toss_context[var_name] = value;
        } else {
          return _toss_context[args[0]];
        }
      };
      cb_callcheck.args = function() {
        return _toss_context.args;
      };
      cb_callcheck.setArgs = function(args) {
        return _toss_context.args = args;
      };
      return cb_callcheck;
    };
    _call_next_fn = function() {
      var cb, err, error1, fn, func_name, isErrorHandlable, marker, newErr, tossArgs;
      err = arguments[0], tossArgs = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      if (err) {
        err.msg = err.toString();
        err.hint = err.hint || hint;
        err.ficentFn = err.ficentFn || startFn;
      }
      if (flowFns.length === _toss_context.fnInx) {
        return outCallback.apply(null, [err].concat(slice.call(tossArgs)));
      }
      fn = flowFns[_toss_context.fnInx];
      _toss_context.fnInx++;
      if (_isString(fn)) {
        marker = 'plug-socket:';
        if (fn.substr(0, marker.length) === marker) {
          func_name = fn.substr(marker.length);
          if (_isFunction(startFn[func_name])) {
            fn = startFn[func_name];
          }
        }
      }
      if (_isArray(fn)) {
        fn = createMuxFn({
          desc: fn.desc + ".fork-wrap"
        }, fn);
      }
      if (_isString(fn)) {
        return _call_next_fn.apply(null, [err].concat(slice.call(tossArgs)));
      }
      if (!_isFunction(fn)) {
        outCallback(new Error('ficent only accept Function or Array or Label'));
        return;
      }
      isErrorHandlable = fn.length === startArgs.length + 2;
      if (err && !isErrorHandlable) {
        return _call_next_fn(err);
      }
      try {
        cb = _createTmpCB(fn.desc);
        cb.setArgs(tossArgs);
        if (isErrorHandlable) {
          return fn.apply(null, [err].concat(slice.call(startArgs), [cb]));
        } else {
          return fn.apply(null, slice.call(startArgs).concat([cb]));
        }
      } catch (error1) {
        newErr = error1;
        return _call_next_fn(newErr);
      }
    };
    _call_next_fn.apply(null, [startErr].concat(slice.call(args)));
    return _toss_context;
  };
  for (k in hint) {
    if (!hasProp.call(hint, k)) continue;
    v = hint[k];
    Object.defineProperty(startFn, k, {
      value: v,
      writable: true
    });
  }
  startFn.desc = startFn.desc || 'ficent';
  _validating(flowFns, startFn.desc);
  return startFn;
};

ficent = function() {
  var args;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  return ficent.flow.apply(ficent, args);
};

ficent.wrap = function(preFns, postFns) {
  if (!_isArray(preFns)) {
    preFns = [preFns];
  }
  if (!_isArray(postFns)) {
    postFns = [postFns];
  }
  return function(inFns) {
    if (!_isArray(inFns)) {
      inFns = [inFns];
    }
    return ficent.flow(slice.call(preFns).concat(slice.call(inFns), slice.call(postFns)));
  };
};

ficent.join = createJoin;

ficent.flow = createSeqFn;

ficent.fork = createMuxFn;

ficent.ser = ficent.series = function() {
  var args, taskFn;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  taskFn = ficent.apply(null, args);
  return function(input_array, outCallback) {
    var f, fns, results_array, seriesCallback;
    results_array = [];
    fns = input_array.map(function(args) {
      if (!_isArray(args)) {
        args = [args];
      }
      return function(_toss) {
        return taskFn.apply(null, slice.call(args).concat([_toss.err(function() {
          var err, results_values;
          err = arguments[0], results_values = 2 <= arguments.length ? slice.call(arguments, 1) : [];
          if (results_values.length === 1) {
            results_values = results_values[0];
          }
          results_array.push(results_values);
          return _toss(err);
        })]));
      };
    });
    f = ficent.flow({
      desc: "series-of." + taskFn.desc
    }, fns);
    seriesCallback = function(err) {
      return outCallback(err, results_array);
    };
    return f(seriesCallback);
  };
};

ficent.par = ficent.parallel = function() {
  var args, taskFn;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  taskFn = ficent.apply(null, args);
  return function(input_array, outCallback) {
    var f, fns;
    fns = input_array.map(function(args) {
      if (!_isArray(args)) {
        args = [args];
      }
      return function(next) {
        return taskFn.apply(null, slice.call(args).concat([next]));
      };
    });
    f = ficent.fork(fns);
    return f(outCallback);
  };
};

module.exports = exports = ficent;
