// Generated by CoffeeScript 1.10.0
var _alignArgs, _defaultCallbackFn, _isArray, _isError, _isFunction, _isNumeric, _isObject, _isString, callContext, createJoin, createMuxFn, createSeqFn, debug, exports, ficent,
  slice = [].slice;

debug = require('debug')('ficent');


/*
라이브러리의 목적
Error 핸들링에 초점 
직/병렬 동시 서술
+ 가변인수 = arity를 기준으로하여 처리가능.
+ 배열 병렬- > context로 Array만 들어올수있을까? 가능성은..? 있다. 누산기로 쓸수도 있고..
  고로 배열 병렬은 다른 시작점을 걸고 연결할수 있게 해보자.
  로직의 재활용을 위한것이니 로직은 고정이다. 그러면, 입력을 억지로 맞추는것보다 그대로 넘기는게 낫다. 
+ retry -> 이건 확실히 다른 시작점을 걸어야 한다.
    유틸리티 형태도 될듯...
+ waterfall 과감히 삭제. 실효성이 많이 없다. 딱딱 떨어지는 경우도 거의 없고...
 */


/*
Error 처리가 핵심이다. 
그렇다면, Error Handler를 식별해야하는데, 1. Arity로 식별. 2. 고유 Property로 식별
Arity로 체크해도 무방 할듯하다. 어차피 입력 컨텍스트가 다르면, 무소용이니까..
다만, 가변 인수인 경우. -> 가변인수인 함수를 물리는 케이스가 있을까...?
그런데 이렇게 간다면...Async와 비슷해지지 않는가?
Arity가 다르면, 아규먼트도 다를테니, 별 문제가 없겠다.

다만, Ficent로 묶었는데, Ficent의 입력으로 애초부터 Err가 포함되어 오는 경우는?
달리, Null부터 오는 경우는...?
처음 호출될떄, 첫 인수가 Error인경우와 아닌경우 Base Arity를 조정하면 될까?
첫 인수가 NULL이거나 Err일때를 Callback 상황으로 가정하면 별 문제 없을듯...
일반적인 경우 첫 인수가 NULL인경우는 거의 없다..
 */


/*
병렬화 다중화 정리 
 
1 서로 다른 함수에 , 서로 다른 데이터.
2 서로 다른 함수에 , 같은 데이터
3 같은 함수에, 서로 다른 데이터.
4 같은 함수에 같은 데이터.???? -> 몇번을 실행하던 결과가 같겠지.. 뭐하러..?
따라서 1~3 케이스만 고려

1. join(Fork–join model)으로 해결, 함수를 시작시키는 것을 체계화하기 힘들다. 
2. fork/flow로 해결 -> 병렬 실행 / 순차 실행의 차이일뿐
3. serial / parallel로 해결 -> 병렬 실행 / 순차 실행의 차이일뿐.
 */

_isNumeric = function(obj) {
  return !_isArray(obj) && (obj - parseFloat(obj) + 1) >= 0;
};

_isString = function(obj) {
  return typeof obj === 'string' || obj instanceof String;
};

_isArray = Array.isArray || function(obj) {
  return Object.prototype.toString.call(obj) === "[object Array]";
};

_isError = function(obj) {
  return obj instanceof Error;
};

_isFunction = function(obj) {
  return !!(obj && obj.constructor && obj.call && obj.apply);
};

_isObject = function(obj) {
  return !!obj && obj.constructor === Object;
};

_defaultCallbackFn = function(err) {
  if (err) {
    console.error(err);
    console.error(err.stack);
    throw err;
  }
};

_alignArgs = function() {
  var args, maybeCallback, maybeError;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  debug('_alignArgs input:', args);
  maybeError = args[0];
  maybeCallback = args[args.length - 1];
  if (maybeError === null || maybeError === void 0 || _isError(maybeError)) {
    args.shift();
  } else {
    maybeError = null;
  }
  if (_isFunction(maybeCallback)) {
    args.pop();
  } else {
    maybeCallback = _defaultCallbackFn;
  }
  debug('_alignArgs', maybeError, args, maybeCallback);
  return [maybeError, args, maybeCallback];
};

createJoin = function() {
  var checkEnd, context, getUnifyErrors, inbound, outbound;
  getUnifyErrors = function() {
    var err_objects, error;
    err_objects = context.errors.filter(function(err) {
      return err;
    });
    error = void 0;
    if (err_objects.length > 0) {
      error = err_objects[0];
    }
    return error;
  };
  checkEnd = function() {
    var all_done, err;
    all_done = context.finished.every(function(v) {
      return v;
    });
    if (!all_done) {
      return;
    }
    if (context.outCallback) {
      err = getUnifyErrors();
      debug.apply(null, ['join done'].concat(slice.call(context.results)));
      return context.outCallback.apply(context, [err].concat(slice.call(context.results)));
    }
  };
  inbound = function() {
    var _tosser;
    _tosser = function() {
      var err, values;
      err = arguments[0], values = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      if (context.is_canceled === true) {
        return;
      }
      if (_tosser.called === true) {
        err = err || new Error('should call `callback` once');
        context.is_canceled = true;
      }
      _tosser.called = true;
      context.errors[_tosser.inx] = err;
      context.results[_tosser.inx] = values;
      context.finished[_tosser.inx] = true;
      return checkEnd();
    };
    _tosser.inx = context.errors.length;
    context.errors.push(void 0);
    context.results.push(void 0);
    context.finished.push(false);
    return _tosser;
  };
  outbound = function(fn) {
    context.outCallback = fn;
    return checkEnd();
  };
  context = {
    is_canceled: false,
    "in": inbound,
    out: outbound,
    outCallback: null,
    errors: [],
    results: [],
    finished: []
  };
  return context;
};

createMuxFn = function(fns) {
  var entryFn;
  entryFn = function() {
    var args, context, forkingFns, outCallback, ref, startArgs, startErr;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    ref = _alignArgs.apply(null, args), startErr = ref[0], startArgs = ref[1], outCallback = ref[2];
    context = createJoin();
    forkingFns = fns.map(function(fn, inx) {
      return createSeqFn(fn);
    });
    context.muxContext = [];
    forkingFns.forEach(function(fn, inx) {
      var ctx;
      ctx = fn.apply(null, [startErr].concat(slice.call(startArgs), [context["in"]()]));
      return context.muxContext.push(ctx);
    });
    context.out(outCallback);
    context.cancel = function() {
      var ctx, i, len, ref1, results;
      context.is_canceled = true;
      ref1 = context.muxContext;
      results = [];
      for (i = 0, len = ref1.length; i < len; i++) {
        ctx = ref1[i];
        results.push(ctx.cancel());
      }
      return results;
    };
    return context;
  };
  return entryFn;
};

callContext = function(flowFns, startArgs, cb) {
  var call_next_fn, context, do_cancel, make_tosser;
  make_tosser = function() {
    var _tosser;
    _tosser = function() {
      var args, err;
      err = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      if (context.is_canceled === true) {
        return;
      }
      if (_tosser.called === true) {
        err = err || new Error('should call `callback` once');
        call_next_fn(err);
        context.is_canceled = true;
        return;
      }
      _tosser.called = true;
      debug.apply(null, ['_tosser takes', err].concat(slice.call(args)));
      return call_next_fn.apply(null, [err].concat(slice.call(args)));
    };
    _tosser.err = function(extend_fn) {
      return function() {
        var args, err, error1, maybeError;
        maybeError = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        if (_isError(maybeError)) {
          return _tosser.apply(null, [maybeError].concat(slice.call(args)));
        }
        try {
          return extend_fn.apply(null, [maybeError].concat(slice.call(args)));
        } catch (error1) {
          err = error1;
          return _tosser(err);
        }
      };
    };
    _tosser.cancel = function(err) {
      if (err == null) {
        err = new Error('Canceled');
      }
      context.fnInx = flowFns.length;
      _tosser(err);
      return context.is_canceled = true;
    };
    _tosser["return"] = function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      context.fnInx = flowFns.length;
      return _tosser.apply(null, args);
    };
    _tosser.goto = function() {
      var args, inx, label;
      label = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      if (label === 'first') {
        inx = 0;
      } else if (label === 'last') {
        inx = flowFns.length - 1;
      } else {
        inx = flowFns.indexOf(label);
        if (inx < 0) {
          throw new Error('Failed to goto ' + label);
        }
      }
      context.fnInx = inx;
      return _tosser.apply(null, [null].concat(slice.call(args)));
    };
    _tosser.getArgs = function() {
      return _tosser.args();
    };
    _tosser.args = function() {
      return _tosser.argv;
    };
    _tosser.setArgs = function(args) {
      return _tosser.argv = args;
    };
    _tosser.setVar = function() {
      var names;
      names = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return _tosser.err(function() {
        var args, err, i, inx, len, n, value;
        err = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        for (inx = i = 0, len = args.length; i < len; inx = ++i) {
          value = args[inx];
          n = names[inx];
          if (n) {
            _tosser["var"](n, value);
          }
        }
        return _tosser.apply(null, [err].concat(slice.call(args)));
      });
    };
    _tosser.getVar = function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return _tosser["var"].apply(_tosser, args);
    };
    _tosser["var"] = function() {
      var args, value, var_name;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      if (args.length === 2) {
        var_name = args[0], value = args[1];
        return context.vars[var_name] = value;
      } else {
        return context.vars[args[0]];
      }
    };
    return _tosser;
  };
  do_cancel = function() {
    return context.is_canceled = true;
  };
  call_next_fn = function() {
    var _toss, cur_fn, cur_fn_is_error_handler, err, error1, newErr, tossArgs;
    err = arguments[0], tossArgs = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    if (flowFns.length === context.fnInx) {
      return context.outCallback.apply(context, [err].concat(slice.call(tossArgs)));
    }
    cur_fn = flowFns[context.fnInx];
    context.fnInx++;
    if (_isArray(cur_fn)) {
      cur_fn = createMuxFn(cur_fn);
    }
    if (_isString(cur_fn)) {
      return call_next_fn.apply(null, [err].concat(slice.call(tossArgs)));
    }
    if (!_isFunction(cur_fn)) {
      context.outCallback(new Error('ficent only accept Function or Array or Label'));
      return;
    }
    cur_fn_is_error_handler = cur_fn.length === context.startArgs.length + 2;
    if (err && !cur_fn_is_error_handler) {
      return call_next_fn(err);
    }
    try {
      _toss = make_tosser();
      _toss.setArgs(tossArgs);
      if (cur_fn_is_error_handler) {
        debug('try call', cur_fn, [err].concat(slice.call(context.startArgs), [_toss]));
        debug('try call, scope =', context.scope);
        return cur_fn.apply(context, [err].concat(slice.call(context.startArgs), [_toss]));
      } else {
        debug('try call', cur_fn, slice.call(context.startArgs).concat([_toss]));
        debug('try call, scope =', context.scope);
        return cur_fn.apply(context, slice.call(context.startArgs).concat([_toss]));
      }
    } catch (error1) {
      newErr = error1;
      return call_next_fn(newErr);
    }
  };
  context = {
    is_canceled: false,
    fnInx: 0,
    flowFns: flowFns,
    startArgs: startArgs,
    outCallback: cb,
    vars: {},
    next: call_next_fn,
    cancel: do_cancel
  };
  return context;
};

createSeqFn = function(flowFns) {
  var entryFn;
  if (!_isArray(flowFns)) {
    flowFns = [flowFns];
  }
  entryFn = function() {
    var args, callback, context, ref, startArgs, startErr;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    ref = _alignArgs.apply(null, args), startErr = ref[0], startArgs = ref[1], callback = ref[2];
    debug('entryFn', startErr, startArgs, callback);
    context = callContext(flowFns, startArgs, callback);
    context.next(startErr);
    return context;
  };
  return entryFn;
};

ficent = function() {
  var args;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  return ficent.flow.apply(ficent, args);
};

ficent.join = createJoin;

ficent.flow = createSeqFn;

ficent.fork = createMuxFn;

ficent.ser = ficent.series = function() {
  var args, taskFn;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  taskFn = ficent.apply(null, args);
  return function(input_array, outCallback) {
    var f, fns, results_array, seriesCallback;
    results_array = [];
    fns = input_array.map(function(args) {
      if (!_isArray(args)) {
        args = [args];
      }
      debug('mk Closure Fn with ', args);
      return function(_toss) {
        debug('inside par', args);
        debug('call series - each task', '_toss._tossable?', _toss._tossable);
        return taskFn.apply(null, slice.call(args).concat([_toss.err(function() {
          var err, results_values;
          err = arguments[0], results_values = 2 <= arguments.length ? slice.call(arguments, 1) : [];
          if (results_values.length === 1) {
            results_values = results_values[0];
          }
          results_array.push(results_values);
          return _toss(err);
        })]));
      };
    });
    f = ficent.flow(fns);
    seriesCallback = function(err) {
      return outCallback(err, results_array);
    };
    return f(seriesCallback);
  };
};

ficent.par = ficent.parallel = function() {
  var args, taskFn;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  taskFn = ficent.apply(null, args);
  return function(input_array, outCallback) {
    var f, fns;
    fns = input_array.map(function(args) {
      if (!_isArray(args)) {
        args = [args];
      }
      debug('mk Closure Fn with ', args);
      return function(next) {
        return taskFn.apply(null, slice.call(args).concat([next]));
      };
    });
    f = ficent.fork(fns);
    return f(outCallback);
  };
};

ficent.wrap = function(preFns, postFns) {
  if (!_isArray(preFns)) {
    preFns = [preFns];
  }
  if (!_isArray(postFns)) {
    postFns = [postFns];
  }
  return function(inFns) {
    if (!_isArray(inFns)) {
      inFns = [inFns];
    }
    return ficent.flow(slice.call(preFns).concat(slice.call(inFns), slice.call(postFns)));
  };
};

module.exports = exports = ficent;
